<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::Crypto::AesCcm Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d2/dde/classThread_1_1Crypto_1_1AesCcm.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="../../d6/db1/classThread_1_1Crypto_1_1AesCcm-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::Crypto::AesCcm Class Reference<div class="ingroups"><a class="el" href="../../d0/de1/group__core.html">Core</a> &raquo; <a class="el" href="../../dd/dcf/group__core-security.html">Security</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>This class implements AES CCM computation.  
 <a href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="../../d0/da7/aes__ccm_8hpp_source.html">src/core/crypto/aes_ccm.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afa12aabd74472bb1c8bf6e8bb73430d4"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#afa12aabd74472bb1c8bf6e8bb73430d4">SetKey</a> (const uint8_t *aKey, uint16_t aKeyLength)</td></tr>
<tr class="memdesc:afa12aabd74472bb1c8bf6e8bb73430d4"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method sets the key.  <a href="#afa12aabd74472bb1c8bf6e8bb73430d4">More...</a><br /></td></tr>
<tr class="separator:afa12aabd74472bb1c8bf6e8bb73430d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7dabbd99f28efd22176e6fed8ce2eb3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#aa7dabbd99f28efd22176e6fed8ce2eb3">Init</a> (uint32_t aHeaderLength, uint32_t aPlainTextLength, uint8_t aTagLength, const void *aNonce, uint8_t aNonceLength)</td></tr>
<tr class="memdesc:aa7dabbd99f28efd22176e6fed8ce2eb3"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method initializes the AES CCM computation.  <a href="#aa7dabbd99f28efd22176e6fed8ce2eb3">More...</a><br /></td></tr>
<tr class="separator:aa7dabbd99f28efd22176e6fed8ce2eb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c363bc7a25302a14931bb33d41ee15a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a2c363bc7a25302a14931bb33d41ee15a">Header</a> (const void *aHeader, uint32_t aHeaderLength)</td></tr>
<tr class="memdesc:a2c363bc7a25302a14931bb33d41ee15a"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method processes the header.  <a href="#a2c363bc7a25302a14931bb33d41ee15a">More...</a><br /></td></tr>
<tr class="separator:a2c363bc7a25302a14931bb33d41ee15a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d36c3f13b85f66ea1e51627ec7d4297"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a5d36c3f13b85f66ea1e51627ec7d4297">Payload</a> (void *aPlainText, void *aCipherText, uint32_t aLength, bool aEncrypt)</td></tr>
<tr class="memdesc:a5d36c3f13b85f66ea1e51627ec7d4297"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method processes the payload.  <a href="#a5d36c3f13b85f66ea1e51627ec7d4297">More...</a><br /></td></tr>
<tr class="separator:a5d36c3f13b85f66ea1e51627ec7d4297"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a666e2ddbf5e0cf91abc191221254fcb8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a666e2ddbf5e0cf91abc191221254fcb8">Finalize</a> (void *aTag, uint8_t *aTagLength)</td></tr>
<tr class="memdesc:a666e2ddbf5e0cf91abc191221254fcb8"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method generates the tag.  <a href="#a666e2ddbf5e0cf91abc191221254fcb8">More...</a><br /></td></tr>
<tr class="separator:a666e2ddbf5e0cf91abc191221254fcb8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements AES CCM computation. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a666e2ddbf5e0cf91abc191221254fcb8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::AesCcm::Finalize </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>aTag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>aTagLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method generates the tag. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">aTag</td><td>A pointer to the tag. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">aTagLength</td><td>Length of the tag in bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_cgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_cgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_cgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_cgraph">
<area shape="rect" id="node2" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#ad04c88631904f76101b5494c485b91d4" title="This method encrypts data. " alt="" coords="221,5,385,44"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_icgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_icgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_icgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_a666e2ddbf5e0cf91abc191221254fcb8_icgraph">
<area shape="rect" id="node2" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aacc5fd2b9ea373a699840afa8e562dc9" title="This method registers a new MAC sender client. " alt="" coords="490,55,696,93"/>
<area shape="rect" id="node13" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#adb6ca8a4287b21a2f9e35090ed716506" title="This method is called to handle transmit events. " alt="" coords="235,27,422,65"/>
<area shape="rect" id="node15" href="../../df/d94/group__core-mle-core.html#ga0ea27201cf13a4e1b0680a9da6c54a64" title="This method submits an MLE message to the UDP socket. " alt="" coords="221,324,435,349"/>
<area shape="rect" id="node3" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a7668817d03306dadcb36ff9eaad72299" title="This method is called by the address resolver when an EID&#45;to&#45;RLOC mapping has been resolved..." alt="" coords="781,55,945,93"/>
<area shape="rect" id="node4" href="../../d4/dcf/classThread_1_1AddressResolver.html#ac249179518a77ecfdaf7d4502ef2f940" title="This method returns the RLOC16 for a given EID, or initiates an Address Query if the mapping is not k..." alt="" coords="1034,55,1207,93"/>
<area shape="rect" id="node5" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a361ef901f6b665b3c7feac206089a7df" title="This method submits a message to the mesh forwarder for forwarding. " alt="" coords="1593,169,1757,208"/>
<area shape="rect" id="node6" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a3a55dcf590bf5941d216ff313b6ce0d0" title="This method gets the Data Poll period. " alt="" coords="1865,169,2029,208"/>
<area shape="rect" id="node7" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a5f726671448fb7cd72f8ee96db40731a" title="This method sets the scan parameters for MLE Discovery Request messages. " alt="" coords="1862,295,2031,333"/>
<area shape="rect" id="node12" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a95f2ad1f6785b0de74e660e43ac86d33" title="This method submits a message to the network interface. " alt="" coords="1876,232,2017,271"/>
<area shape="rect" id="node8" href="../../df/d94/group__core-mle-core.html#gab299d00d1b2beabe8130e400dd6eca91" title="This method initiates a Thread Discovery. " alt="" coords="2098,276,2278,301"/>
<area shape="rect" id="node9" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="2333,245,2507,284"/>
<area shape="rect" id="node10" href="../../d0/d0a/group__commands.html#ga8422cdf7d0b8b22c6dd107e6bb1309f2" title="This function starts a Thread Discovery scan. " alt="" coords="2378,308,2462,333"/>
<area shape="rect" id="node11" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="2555,428,2710,467"/>
<area shape="rect" id="node14" href="../../d7/d9c/group__radio-operation.html#ga7d10a9bce7521f75bd84b32b979e1aa7" title="The radio driver calls this method to notify OpenThread that the transmission has completed..." alt="" coords="507,5,680,31"/>
<area shape="rect" id="node16" href="../../df/d94/group__core-mle-core.html#gace8437c6340cefbd5db1a53f9e00422b" title="This method appends a Pending Timestamp TLV to a message. " alt="" coords="775,449,950,488"/>
<area shape="rect" id="node17" href="../../df/d94/group__core-mle-core.html#gac13477847483bba0aeab32fd93a7dbac" title="This method generates an MLE Data Request message. " alt="" coords="1026,620,1215,659"/>
<area shape="rect" id="node18" href="../../db/dec/group__core-mle-router.html#ga12a2afd1fef5036981d7f1f05d3e6f01" title="This method sets the ROUTER_DOWNGRADE_THRESHOLD value. " alt="" coords="1275,627,1491,665"/>
<area shape="rect" id="node22" href="../../db/dec/group__core-mle-router.html#gac532b9ffa61813ee2c1463b6820c8c75" title="This method returns the number of active routers. " alt="" coords="1039,449,1202,488"/>
<area shape="rect" id="node28" href="../../df/d94/group__core-mle-core.html#ga09239c621861382d25163980ab5d983b" title="This method generates an MLE Child Update Request message. " alt="" coords="498,400,689,439"/>
<area shape="rect" id="node35" href="../../df/d94/group__core-mle-core.html#ga91214fcb8db3271fc3ad0472e38c1e0a" title="This method generates an MLE Announce message. " alt="" coords="483,197,703,223"/>
<area shape="rect" id="node37" href="../../db/dec/group__core-mle-router.html#ga7126c084ace25827febebc4210928cd4" title="This method generates an MLE Link Reject. " alt="" coords="1040,233,1201,272"/>
<area shape="rect" id="node19" href="../../db/d57/group__config-test.html#ga907be1830046930bb04f606dc6dc3ec1" title="Set the ROUTER_DOWNGRADE_THRESHOLD parameter used in the Leader role. " alt="" coords="1565,625,1785,651"/>
<area shape="rect" id="node20" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="1851,511,2043,549"/>
<area shape="rect" id="node21" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="2091,511,2285,549"/>
<area shape="rect" id="node23" href="../../db/dec/group__core-mle-router.html#gac7d2542017033898d0bc0f17a65d4656" title="This method checks if the destination is reachable. " alt="" coords="1302,284,1464,323"/>
<area shape="rect" id="node24" href="../../db/dec/group__core-mle-router.html#gadf4904db11b31b2931f2f5ed1b988f83" title="This method fills an RouteTlv. " alt="" coords="1302,449,1464,488"/>
<area shape="rect" id="node26" href="../../dd/dd1/classThread_1_1NetworkData_1_1Local.html#a6688957845dc3ee7fc08bbc50145d98e" title="This method sends a Server Data Notification message to the Leader. " alt="" coords="1267,512,1499,551"/>
<area shape="rect" id="node25" href="../../d6/d17/classThread_1_1NetworkDiagnostic_1_1NetworkDiagnostic.html#aabefee38f58e0a8bcd39650ccc386e12" title="This method fills ChildTableTlv. " alt="" coords="1547,456,1803,495"/>
<area shape="rect" id="node27" href="../../db/da2/group__config-br.html#gaf9f7e49c190e8e11297d534e223d6274" title="Immediately register the local network data with the Leader. " alt="" coords="1610,519,1741,544"/>
<area shape="rect" id="node29" href="../../df/d94/group__core-mle-core.html#ga01c7e5a022360a6f35e30d07221dbfea" title="This method starts the MLE protocol operation. " alt="" coords="784,299,941,324"/>
<area shape="rect" id="node31" href="../../df/d94/group__core-mle-core.html#gafb51db61e6e184d664a9e7cc3833dcf4" title="This method sets the MLE Timeout value. " alt="" coords="1022,568,1219,593"/>
<area shape="rect" id="node33" href="../../df/d94/group__core-mle-core.html#ga453d94c377c5825a4a5e8b66a728e591" title="This method sets the Device Mode as reported in the Mode TLV. " alt="" coords="751,400,974,425"/>
<area shape="rect" id="node30" href="../../d0/d0a/group__commands.html#ga62fbc1cdb7b036df73975ca5683f8573" title="This function starts Thread protocol operation. " alt="" coords="1624,357,1726,383"/>
<area shape="rect" id="node32" href="../../df/d4f/group__config-general.html#ga6b28b99c77378da98922a3d994b7641c" title="Set the Thread Child Timeout used when operating in the Child role. " alt="" coords="1610,575,1740,600"/>
<area shape="rect" id="node34" href="../../df/d4f/group__config-general.html#ga8263fa852e25758aad3636bce0069a0d" title="Set the MLE Link Mode configuration. " alt="" coords="1620,407,1730,432"/>
<area shape="rect" id="node36" href="../../da/d6e/classThread_1_1AnnounceBeginServer.html#a0ec55dcc678b320251be99112cfc037b" title="This method begins the MLE Announce transmission process. " alt="" coords="761,184,965,223"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a2c363bc7a25302a14931bb33d41ee15a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::AesCcm::Header </td>
          <td>(</td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>aHeader</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>aHeaderLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method processes the header. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aHeader</td><td>A pointer to the header. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aHeaderLength</td><td>Length of header in bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_cgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_cgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_cgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_cgraph">
<area shape="rect" id="node2" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#ad04c88631904f76101b5494c485b91d4" title="This method encrypts data. " alt="" coords="221,5,385,44"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_icgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_icgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_icgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_a2c363bc7a25302a14931bb33d41ee15a_icgraph">
<area shape="rect" id="node2" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aacc5fd2b9ea373a699840afa8e562dc9" title="This method registers a new MAC sender client. " alt="" coords="490,55,696,93"/>
<area shape="rect" id="node13" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#adb6ca8a4287b21a2f9e35090ed716506" title="This method is called to handle transmit events. " alt="" coords="235,27,422,65"/>
<area shape="rect" id="node15" href="../../df/d94/group__core-mle-core.html#ga0ea27201cf13a4e1b0680a9da6c54a64" title="This method submits an MLE message to the UDP socket. " alt="" coords="221,324,435,349"/>
<area shape="rect" id="node3" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a7668817d03306dadcb36ff9eaad72299" title="This method is called by the address resolver when an EID&#45;to&#45;RLOC mapping has been resolved..." alt="" coords="781,55,945,93"/>
<area shape="rect" id="node4" href="../../d4/dcf/classThread_1_1AddressResolver.html#ac249179518a77ecfdaf7d4502ef2f940" title="This method returns the RLOC16 for a given EID, or initiates an Address Query if the mapping is not k..." alt="" coords="1034,55,1207,93"/>
<area shape="rect" id="node5" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a361ef901f6b665b3c7feac206089a7df" title="This method submits a message to the mesh forwarder for forwarding. " alt="" coords="1593,169,1757,208"/>
<area shape="rect" id="node6" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a3a55dcf590bf5941d216ff313b6ce0d0" title="This method gets the Data Poll period. " alt="" coords="1865,169,2029,208"/>
<area shape="rect" id="node7" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a5f726671448fb7cd72f8ee96db40731a" title="This method sets the scan parameters for MLE Discovery Request messages. " alt="" coords="1862,295,2031,333"/>
<area shape="rect" id="node12" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a95f2ad1f6785b0de74e660e43ac86d33" title="This method submits a message to the network interface. " alt="" coords="1876,232,2017,271"/>
<area shape="rect" id="node8" href="../../df/d94/group__core-mle-core.html#gab299d00d1b2beabe8130e400dd6eca91" title="This method initiates a Thread Discovery. " alt="" coords="2098,276,2278,301"/>
<area shape="rect" id="node9" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="2333,245,2507,284"/>
<area shape="rect" id="node10" href="../../d0/d0a/group__commands.html#ga8422cdf7d0b8b22c6dd107e6bb1309f2" title="This function starts a Thread Discovery scan. " alt="" coords="2378,308,2462,333"/>
<area shape="rect" id="node11" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="2555,428,2710,467"/>
<area shape="rect" id="node14" href="../../d7/d9c/group__radio-operation.html#ga7d10a9bce7521f75bd84b32b979e1aa7" title="The radio driver calls this method to notify OpenThread that the transmission has completed..." alt="" coords="507,5,680,31"/>
<area shape="rect" id="node16" href="../../df/d94/group__core-mle-core.html#gace8437c6340cefbd5db1a53f9e00422b" title="This method appends a Pending Timestamp TLV to a message. " alt="" coords="775,449,950,488"/>
<area shape="rect" id="node17" href="../../df/d94/group__core-mle-core.html#gac13477847483bba0aeab32fd93a7dbac" title="This method generates an MLE Data Request message. " alt="" coords="1026,620,1215,659"/>
<area shape="rect" id="node18" href="../../db/dec/group__core-mle-router.html#ga12a2afd1fef5036981d7f1f05d3e6f01" title="This method sets the ROUTER_DOWNGRADE_THRESHOLD value. " alt="" coords="1275,627,1491,665"/>
<area shape="rect" id="node22" href="../../db/dec/group__core-mle-router.html#gac532b9ffa61813ee2c1463b6820c8c75" title="This method returns the number of active routers. " alt="" coords="1039,449,1202,488"/>
<area shape="rect" id="node28" href="../../df/d94/group__core-mle-core.html#ga09239c621861382d25163980ab5d983b" title="This method generates an MLE Child Update Request message. " alt="" coords="498,400,689,439"/>
<area shape="rect" id="node35" href="../../df/d94/group__core-mle-core.html#ga91214fcb8db3271fc3ad0472e38c1e0a" title="This method generates an MLE Announce message. " alt="" coords="483,197,703,223"/>
<area shape="rect" id="node37" href="../../db/dec/group__core-mle-router.html#ga7126c084ace25827febebc4210928cd4" title="This method generates an MLE Link Reject. " alt="" coords="1040,233,1201,272"/>
<area shape="rect" id="node19" href="../../db/d57/group__config-test.html#ga907be1830046930bb04f606dc6dc3ec1" title="Set the ROUTER_DOWNGRADE_THRESHOLD parameter used in the Leader role. " alt="" coords="1565,625,1785,651"/>
<area shape="rect" id="node20" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="1851,511,2043,549"/>
<area shape="rect" id="node21" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="2091,511,2285,549"/>
<area shape="rect" id="node23" href="../../db/dec/group__core-mle-router.html#gac7d2542017033898d0bc0f17a65d4656" title="This method checks if the destination is reachable. " alt="" coords="1302,284,1464,323"/>
<area shape="rect" id="node24" href="../../db/dec/group__core-mle-router.html#gadf4904db11b31b2931f2f5ed1b988f83" title="This method fills an RouteTlv. " alt="" coords="1302,449,1464,488"/>
<area shape="rect" id="node26" href="../../dd/dd1/classThread_1_1NetworkData_1_1Local.html#a6688957845dc3ee7fc08bbc50145d98e" title="This method sends a Server Data Notification message to the Leader. " alt="" coords="1267,512,1499,551"/>
<area shape="rect" id="node25" href="../../d6/d17/classThread_1_1NetworkDiagnostic_1_1NetworkDiagnostic.html#aabefee38f58e0a8bcd39650ccc386e12" title="This method fills ChildTableTlv. " alt="" coords="1547,456,1803,495"/>
<area shape="rect" id="node27" href="../../db/da2/group__config-br.html#gaf9f7e49c190e8e11297d534e223d6274" title="Immediately register the local network data with the Leader. " alt="" coords="1610,519,1741,544"/>
<area shape="rect" id="node29" href="../../df/d94/group__core-mle-core.html#ga01c7e5a022360a6f35e30d07221dbfea" title="This method starts the MLE protocol operation. " alt="" coords="784,299,941,324"/>
<area shape="rect" id="node31" href="../../df/d94/group__core-mle-core.html#gafb51db61e6e184d664a9e7cc3833dcf4" title="This method sets the MLE Timeout value. " alt="" coords="1022,568,1219,593"/>
<area shape="rect" id="node33" href="../../df/d94/group__core-mle-core.html#ga453d94c377c5825a4a5e8b66a728e591" title="This method sets the Device Mode as reported in the Mode TLV. " alt="" coords="751,400,974,425"/>
<area shape="rect" id="node30" href="../../d0/d0a/group__commands.html#ga62fbc1cdb7b036df73975ca5683f8573" title="This function starts Thread protocol operation. " alt="" coords="1624,357,1726,383"/>
<area shape="rect" id="node32" href="../../df/d4f/group__config-general.html#ga6b28b99c77378da98922a3d994b7641c" title="Set the Thread Child Timeout used when operating in the Child role. " alt="" coords="1610,575,1740,600"/>
<area shape="rect" id="node34" href="../../df/d4f/group__config-general.html#ga8263fa852e25758aad3636bce0069a0d" title="Set the MLE Link Mode configuration. " alt="" coords="1620,407,1730,432"/>
<area shape="rect" id="node36" href="../../da/d6e/classThread_1_1AnnounceBeginServer.html#a0ec55dcc678b320251be99112cfc037b" title="This method begins the MLE Announce transmission process. " alt="" coords="761,184,965,223"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="aa7dabbd99f28efd22176e6fed8ce2eb3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::AesCcm::Init </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>aHeaderLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>aPlainTextLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aTagLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>aNonce</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aNonceLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method initializes the AES CCM computation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aHeaderLength</td><td>Length of header in bytes. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aPlainTextLength</td><td>Length of plaintext in bytes. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aTagLength</td><td>Length of tag in bytes. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aNonce</td><td>A pointer to the nonce. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aNonceLength</td><td>Length of nonce in bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_cgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_cgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_cgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_cgraph">
<area shape="rect" id="node2" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#ad04c88631904f76101b5494c485b91d4" title="This method encrypts data. " alt="" coords="221,5,385,44"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_icgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_icgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_icgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_aa7dabbd99f28efd22176e6fed8ce2eb3_icgraph">
<area shape="rect" id="node2" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aacc5fd2b9ea373a699840afa8e562dc9" title="This method registers a new MAC sender client. " alt="" coords="490,55,696,93"/>
<area shape="rect" id="node13" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#adb6ca8a4287b21a2f9e35090ed716506" title="This method is called to handle transmit events. " alt="" coords="235,27,422,65"/>
<area shape="rect" id="node15" href="../../df/d94/group__core-mle-core.html#ga0ea27201cf13a4e1b0680a9da6c54a64" title="This method submits an MLE message to the UDP socket. " alt="" coords="221,324,435,349"/>
<area shape="rect" id="node3" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a7668817d03306dadcb36ff9eaad72299" title="This method is called by the address resolver when an EID&#45;to&#45;RLOC mapping has been resolved..." alt="" coords="781,55,945,93"/>
<area shape="rect" id="node4" href="../../d4/dcf/classThread_1_1AddressResolver.html#ac249179518a77ecfdaf7d4502ef2f940" title="This method returns the RLOC16 for a given EID, or initiates an Address Query if the mapping is not k..." alt="" coords="1034,55,1207,93"/>
<area shape="rect" id="node5" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a361ef901f6b665b3c7feac206089a7df" title="This method submits a message to the mesh forwarder for forwarding. " alt="" coords="1593,169,1757,208"/>
<area shape="rect" id="node6" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a3a55dcf590bf5941d216ff313b6ce0d0" title="This method gets the Data Poll period. " alt="" coords="1865,169,2029,208"/>
<area shape="rect" id="node7" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a5f726671448fb7cd72f8ee96db40731a" title="This method sets the scan parameters for MLE Discovery Request messages. " alt="" coords="1862,295,2031,333"/>
<area shape="rect" id="node12" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a95f2ad1f6785b0de74e660e43ac86d33" title="This method submits a message to the network interface. " alt="" coords="1876,232,2017,271"/>
<area shape="rect" id="node8" href="../../df/d94/group__core-mle-core.html#gab299d00d1b2beabe8130e400dd6eca91" title="This method initiates a Thread Discovery. " alt="" coords="2098,276,2278,301"/>
<area shape="rect" id="node9" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="2333,245,2507,284"/>
<area shape="rect" id="node10" href="../../d0/d0a/group__commands.html#ga8422cdf7d0b8b22c6dd107e6bb1309f2" title="This function starts a Thread Discovery scan. " alt="" coords="2378,308,2462,333"/>
<area shape="rect" id="node11" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="2555,428,2710,467"/>
<area shape="rect" id="node14" href="../../d7/d9c/group__radio-operation.html#ga7d10a9bce7521f75bd84b32b979e1aa7" title="The radio driver calls this method to notify OpenThread that the transmission has completed..." alt="" coords="507,5,680,31"/>
<area shape="rect" id="node16" href="../../df/d94/group__core-mle-core.html#gace8437c6340cefbd5db1a53f9e00422b" title="This method appends a Pending Timestamp TLV to a message. " alt="" coords="775,449,950,488"/>
<area shape="rect" id="node17" href="../../df/d94/group__core-mle-core.html#gac13477847483bba0aeab32fd93a7dbac" title="This method generates an MLE Data Request message. " alt="" coords="1026,620,1215,659"/>
<area shape="rect" id="node18" href="../../db/dec/group__core-mle-router.html#ga12a2afd1fef5036981d7f1f05d3e6f01" title="This method sets the ROUTER_DOWNGRADE_THRESHOLD value. " alt="" coords="1275,627,1491,665"/>
<area shape="rect" id="node22" href="../../db/dec/group__core-mle-router.html#gac532b9ffa61813ee2c1463b6820c8c75" title="This method returns the number of active routers. " alt="" coords="1039,449,1202,488"/>
<area shape="rect" id="node28" href="../../df/d94/group__core-mle-core.html#ga09239c621861382d25163980ab5d983b" title="This method generates an MLE Child Update Request message. " alt="" coords="498,400,689,439"/>
<area shape="rect" id="node35" href="../../df/d94/group__core-mle-core.html#ga91214fcb8db3271fc3ad0472e38c1e0a" title="This method generates an MLE Announce message. " alt="" coords="483,197,703,223"/>
<area shape="rect" id="node37" href="../../db/dec/group__core-mle-router.html#ga7126c084ace25827febebc4210928cd4" title="This method generates an MLE Link Reject. " alt="" coords="1040,233,1201,272"/>
<area shape="rect" id="node19" href="../../db/d57/group__config-test.html#ga907be1830046930bb04f606dc6dc3ec1" title="Set the ROUTER_DOWNGRADE_THRESHOLD parameter used in the Leader role. " alt="" coords="1565,625,1785,651"/>
<area shape="rect" id="node20" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="1851,511,2043,549"/>
<area shape="rect" id="node21" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="2091,511,2285,549"/>
<area shape="rect" id="node23" href="../../db/dec/group__core-mle-router.html#gac7d2542017033898d0bc0f17a65d4656" title="This method checks if the destination is reachable. " alt="" coords="1302,284,1464,323"/>
<area shape="rect" id="node24" href="../../db/dec/group__core-mle-router.html#gadf4904db11b31b2931f2f5ed1b988f83" title="This method fills an RouteTlv. " alt="" coords="1302,449,1464,488"/>
<area shape="rect" id="node26" href="../../dd/dd1/classThread_1_1NetworkData_1_1Local.html#a6688957845dc3ee7fc08bbc50145d98e" title="This method sends a Server Data Notification message to the Leader. " alt="" coords="1267,512,1499,551"/>
<area shape="rect" id="node25" href="../../d6/d17/classThread_1_1NetworkDiagnostic_1_1NetworkDiagnostic.html#aabefee38f58e0a8bcd39650ccc386e12" title="This method fills ChildTableTlv. " alt="" coords="1547,456,1803,495"/>
<area shape="rect" id="node27" href="../../db/da2/group__config-br.html#gaf9f7e49c190e8e11297d534e223d6274" title="Immediately register the local network data with the Leader. " alt="" coords="1610,519,1741,544"/>
<area shape="rect" id="node29" href="../../df/d94/group__core-mle-core.html#ga01c7e5a022360a6f35e30d07221dbfea" title="This method starts the MLE protocol operation. " alt="" coords="784,299,941,324"/>
<area shape="rect" id="node31" href="../../df/d94/group__core-mle-core.html#gafb51db61e6e184d664a9e7cc3833dcf4" title="This method sets the MLE Timeout value. " alt="" coords="1022,568,1219,593"/>
<area shape="rect" id="node33" href="../../df/d94/group__core-mle-core.html#ga453d94c377c5825a4a5e8b66a728e591" title="This method sets the Device Mode as reported in the Mode TLV. " alt="" coords="751,400,974,425"/>
<area shape="rect" id="node30" href="../../d0/d0a/group__commands.html#ga62fbc1cdb7b036df73975ca5683f8573" title="This function starts Thread protocol operation. " alt="" coords="1624,357,1726,383"/>
<area shape="rect" id="node32" href="../../df/d4f/group__config-general.html#ga6b28b99c77378da98922a3d994b7641c" title="Set the Thread Child Timeout used when operating in the Child role. " alt="" coords="1610,575,1740,600"/>
<area shape="rect" id="node34" href="../../df/d4f/group__config-general.html#ga8263fa852e25758aad3636bce0069a0d" title="Set the MLE Link Mode configuration. " alt="" coords="1620,407,1730,432"/>
<area shape="rect" id="node36" href="../../da/d6e/classThread_1_1AnnounceBeginServer.html#a0ec55dcc678b320251be99112cfc037b" title="This method begins the MLE Announce transmission process. " alt="" coords="761,184,965,223"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a5d36c3f13b85f66ea1e51627ec7d4297"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Crypto::AesCcm::Payload </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>aPlainText</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>aCipherText</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>aLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>aEncrypt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method processes the payload. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">aPlainText</td><td>A pointer to the plaintext. </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">aCipherText</td><td>A pointer to the ciphertext. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aLength</td><td>Payload length in bytes. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aEncrypt</td><td>TRUE on encrypt and FALSE on decrypt. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_cgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_cgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_cgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_cgraph">
<area shape="rect" id="node2" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#ad04c88631904f76101b5494c485b91d4" title="This method encrypts data. " alt="" coords="221,5,385,44"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_icgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_icgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_icgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_a5d36c3f13b85f66ea1e51627ec7d4297_icgraph">
<area shape="rect" id="node2" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aacc5fd2b9ea373a699840afa8e562dc9" title="This method registers a new MAC sender client. " alt="" coords="490,55,696,93"/>
<area shape="rect" id="node13" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#adb6ca8a4287b21a2f9e35090ed716506" title="This method is called to handle transmit events. " alt="" coords="235,27,422,65"/>
<area shape="rect" id="node15" href="../../df/d94/group__core-mle-core.html#ga0ea27201cf13a4e1b0680a9da6c54a64" title="This method submits an MLE message to the UDP socket. " alt="" coords="221,324,435,349"/>
<area shape="rect" id="node3" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a7668817d03306dadcb36ff9eaad72299" title="This method is called by the address resolver when an EID&#45;to&#45;RLOC mapping has been resolved..." alt="" coords="781,55,945,93"/>
<area shape="rect" id="node4" href="../../d4/dcf/classThread_1_1AddressResolver.html#ac249179518a77ecfdaf7d4502ef2f940" title="This method returns the RLOC16 for a given EID, or initiates an Address Query if the mapping is not k..." alt="" coords="1034,55,1207,93"/>
<area shape="rect" id="node5" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a361ef901f6b665b3c7feac206089a7df" title="This method submits a message to the mesh forwarder for forwarding. " alt="" coords="1593,169,1757,208"/>
<area shape="rect" id="node6" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a3a55dcf590bf5941d216ff313b6ce0d0" title="This method gets the Data Poll period. " alt="" coords="1865,169,2029,208"/>
<area shape="rect" id="node7" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a5f726671448fb7cd72f8ee96db40731a" title="This method sets the scan parameters for MLE Discovery Request messages. " alt="" coords="1862,295,2031,333"/>
<area shape="rect" id="node12" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a95f2ad1f6785b0de74e660e43ac86d33" title="This method submits a message to the network interface. " alt="" coords="1876,232,2017,271"/>
<area shape="rect" id="node8" href="../../df/d94/group__core-mle-core.html#gab299d00d1b2beabe8130e400dd6eca91" title="This method initiates a Thread Discovery. " alt="" coords="2098,276,2278,301"/>
<area shape="rect" id="node9" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="2333,245,2507,284"/>
<area shape="rect" id="node10" href="../../d0/d0a/group__commands.html#ga8422cdf7d0b8b22c6dd107e6bb1309f2" title="This function starts a Thread Discovery scan. " alt="" coords="2378,308,2462,333"/>
<area shape="rect" id="node11" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="2555,428,2710,467"/>
<area shape="rect" id="node14" href="../../d7/d9c/group__radio-operation.html#ga7d10a9bce7521f75bd84b32b979e1aa7" title="The radio driver calls this method to notify OpenThread that the transmission has completed..." alt="" coords="507,5,680,31"/>
<area shape="rect" id="node16" href="../../df/d94/group__core-mle-core.html#gace8437c6340cefbd5db1a53f9e00422b" title="This method appends a Pending Timestamp TLV to a message. " alt="" coords="775,449,950,488"/>
<area shape="rect" id="node17" href="../../df/d94/group__core-mle-core.html#gac13477847483bba0aeab32fd93a7dbac" title="This method generates an MLE Data Request message. " alt="" coords="1026,620,1215,659"/>
<area shape="rect" id="node18" href="../../db/dec/group__core-mle-router.html#ga12a2afd1fef5036981d7f1f05d3e6f01" title="This method sets the ROUTER_DOWNGRADE_THRESHOLD value. " alt="" coords="1275,627,1491,665"/>
<area shape="rect" id="node22" href="../../db/dec/group__core-mle-router.html#gac532b9ffa61813ee2c1463b6820c8c75" title="This method returns the number of active routers. " alt="" coords="1039,449,1202,488"/>
<area shape="rect" id="node28" href="../../df/d94/group__core-mle-core.html#ga09239c621861382d25163980ab5d983b" title="This method generates an MLE Child Update Request message. " alt="" coords="498,400,689,439"/>
<area shape="rect" id="node35" href="../../df/d94/group__core-mle-core.html#ga91214fcb8db3271fc3ad0472e38c1e0a" title="This method generates an MLE Announce message. " alt="" coords="483,197,703,223"/>
<area shape="rect" id="node37" href="../../db/dec/group__core-mle-router.html#ga7126c084ace25827febebc4210928cd4" title="This method generates an MLE Link Reject. " alt="" coords="1040,233,1201,272"/>
<area shape="rect" id="node19" href="../../db/d57/group__config-test.html#ga907be1830046930bb04f606dc6dc3ec1" title="Set the ROUTER_DOWNGRADE_THRESHOLD parameter used in the Leader role. " alt="" coords="1565,625,1785,651"/>
<area shape="rect" id="node20" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="1851,511,2043,549"/>
<area shape="rect" id="node21" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="2091,511,2285,549"/>
<area shape="rect" id="node23" href="../../db/dec/group__core-mle-router.html#gac7d2542017033898d0bc0f17a65d4656" title="This method checks if the destination is reachable. " alt="" coords="1302,284,1464,323"/>
<area shape="rect" id="node24" href="../../db/dec/group__core-mle-router.html#gadf4904db11b31b2931f2f5ed1b988f83" title="This method fills an RouteTlv. " alt="" coords="1302,449,1464,488"/>
<area shape="rect" id="node26" href="../../dd/dd1/classThread_1_1NetworkData_1_1Local.html#a6688957845dc3ee7fc08bbc50145d98e" title="This method sends a Server Data Notification message to the Leader. " alt="" coords="1267,512,1499,551"/>
<area shape="rect" id="node25" href="../../d6/d17/classThread_1_1NetworkDiagnostic_1_1NetworkDiagnostic.html#aabefee38f58e0a8bcd39650ccc386e12" title="This method fills ChildTableTlv. " alt="" coords="1547,456,1803,495"/>
<area shape="rect" id="node27" href="../../db/da2/group__config-br.html#gaf9f7e49c190e8e11297d534e223d6274" title="Immediately register the local network data with the Leader. " alt="" coords="1610,519,1741,544"/>
<area shape="rect" id="node29" href="../../df/d94/group__core-mle-core.html#ga01c7e5a022360a6f35e30d07221dbfea" title="This method starts the MLE protocol operation. " alt="" coords="784,299,941,324"/>
<area shape="rect" id="node31" href="../../df/d94/group__core-mle-core.html#gafb51db61e6e184d664a9e7cc3833dcf4" title="This method sets the MLE Timeout value. " alt="" coords="1022,568,1219,593"/>
<area shape="rect" id="node33" href="../../df/d94/group__core-mle-core.html#ga453d94c377c5825a4a5e8b66a728e591" title="This method sets the Device Mode as reported in the Mode TLV. " alt="" coords="751,400,974,425"/>
<area shape="rect" id="node30" href="../../d0/d0a/group__commands.html#ga62fbc1cdb7b036df73975ca5683f8573" title="This function starts Thread protocol operation. " alt="" coords="1624,357,1726,383"/>
<area shape="rect" id="node32" href="../../df/d4f/group__config-general.html#ga6b28b99c77378da98922a3d994b7641c" title="Set the Thread Child Timeout used when operating in the Child role. " alt="" coords="1610,575,1740,600"/>
<area shape="rect" id="node34" href="../../df/d4f/group__config-general.html#ga8263fa852e25758aad3636bce0069a0d" title="Set the MLE Link Mode configuration. " alt="" coords="1620,407,1730,432"/>
<area shape="rect" id="node36" href="../../da/d6e/classThread_1_1AnnounceBeginServer.html#a0ec55dcc678b320251be99112cfc037b" title="This method begins the MLE Announce transmission process. " alt="" coords="761,184,965,223"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="afa12aabd74472bb1c8bf6e8bb73430d4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Crypto::AesCcm::SetKey </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aKeyLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method sets the key. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aKey</td><td>A pointer to the key. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aKeyLength</td><td>Length of the key in bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_cgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_cgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_cgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_cgraph">
<area shape="rect" id="node2" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#a6c805bc8b44cb66d543b7916bf1cbaad" title="This method sets the key. " alt="" coords="221,5,385,44"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_icgraph.png" border="0" usemap="#d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_icgraph" alt=""/></div>
<map name="d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_icgraph" id="d2/dde/classThread_1_1Crypto_1_1AesCcm_afa12aabd74472bb1c8bf6e8bb73430d4_icgraph">
<area shape="rect" id="node2" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aacc5fd2b9ea373a699840afa8e562dc9" title="This method registers a new MAC sender client. " alt="" coords="490,55,696,93"/>
<area shape="rect" id="node13" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#adb6ca8a4287b21a2f9e35090ed716506" title="This method is called to handle transmit events. " alt="" coords="235,27,422,65"/>
<area shape="rect" id="node15" href="../../df/d94/group__core-mle-core.html#ga0ea27201cf13a4e1b0680a9da6c54a64" title="This method submits an MLE message to the UDP socket. " alt="" coords="221,324,435,349"/>
<area shape="rect" id="node3" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a7668817d03306dadcb36ff9eaad72299" title="This method is called by the address resolver when an EID&#45;to&#45;RLOC mapping has been resolved..." alt="" coords="781,55,945,93"/>
<area shape="rect" id="node4" href="../../d4/dcf/classThread_1_1AddressResolver.html#ac249179518a77ecfdaf7d4502ef2f940" title="This method returns the RLOC16 for a given EID, or initiates an Address Query if the mapping is not k..." alt="" coords="1034,55,1207,93"/>
<area shape="rect" id="node5" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a361ef901f6b665b3c7feac206089a7df" title="This method submits a message to the mesh forwarder for forwarding. " alt="" coords="1593,169,1757,208"/>
<area shape="rect" id="node6" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a3a55dcf590bf5941d216ff313b6ce0d0" title="This method gets the Data Poll period. " alt="" coords="1865,169,2029,208"/>
<area shape="rect" id="node7" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a5f726671448fb7cd72f8ee96db40731a" title="This method sets the scan parameters for MLE Discovery Request messages. " alt="" coords="1862,295,2031,333"/>
<area shape="rect" id="node12" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a95f2ad1f6785b0de74e660e43ac86d33" title="This method submits a message to the network interface. " alt="" coords="1876,232,2017,271"/>
<area shape="rect" id="node8" href="../../df/d94/group__core-mle-core.html#gab299d00d1b2beabe8130e400dd6eca91" title="This method initiates a Thread Discovery. " alt="" coords="2098,276,2278,301"/>
<area shape="rect" id="node9" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html#a1ca1f767cfe15e7c25b8f65606e7fefb" title="This method starts the Joiner service. " alt="" coords="2333,245,2507,284"/>
<area shape="rect" id="node10" href="../../d0/d0a/group__commands.html#ga8422cdf7d0b8b22c6dd107e6bb1309f2" title="This function starts a Thread Discovery scan. " alt="" coords="2378,308,2462,333"/>
<area shape="rect" id="node11" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#a11ee1f86cffe17aab7de3de0bb16dee7" title="This method parses an ASCII string as an unsigned long. " alt="" coords="2555,428,2710,467"/>
<area shape="rect" id="node14" href="../../d7/d9c/group__radio-operation.html#ga7d10a9bce7521f75bd84b32b979e1aa7" title="The radio driver calls this method to notify OpenThread that the transmission has completed..." alt="" coords="507,5,680,31"/>
<area shape="rect" id="node16" href="../../df/d94/group__core-mle-core.html#gace8437c6340cefbd5db1a53f9e00422b" title="This method appends a Pending Timestamp TLV to a message. " alt="" coords="775,449,950,488"/>
<area shape="rect" id="node17" href="../../df/d94/group__core-mle-core.html#gac13477847483bba0aeab32fd93a7dbac" title="This method generates an MLE Data Request message. " alt="" coords="1026,620,1215,659"/>
<area shape="rect" id="node18" href="../../db/dec/group__core-mle-router.html#ga12a2afd1fef5036981d7f1f05d3e6f01" title="This method sets the ROUTER_DOWNGRADE_THRESHOLD value. " alt="" coords="1275,627,1491,665"/>
<area shape="rect" id="node22" href="../../db/dec/group__core-mle-router.html#gac532b9ffa61813ee2c1463b6820c8c75" title="This method returns the number of active routers. " alt="" coords="1039,449,1202,488"/>
<area shape="rect" id="node28" href="../../df/d94/group__core-mle-core.html#ga09239c621861382d25163980ab5d983b" title="This method generates an MLE Child Update Request message. " alt="" coords="498,400,689,439"/>
<area shape="rect" id="node35" href="../../df/d94/group__core-mle-core.html#ga91214fcb8db3271fc3ad0472e38c1e0a" title="This method generates an MLE Announce message. " alt="" coords="483,197,703,223"/>
<area shape="rect" id="node37" href="../../db/dec/group__core-mle-router.html#ga7126c084ace25827febebc4210928cd4" title="This method generates an MLE Link Reject. " alt="" coords="1040,233,1201,272"/>
<area shape="rect" id="node19" href="../../db/d57/group__config-test.html#ga907be1830046930bb04f606dc6dc3ec1" title="Set the ROUTER_DOWNGRADE_THRESHOLD parameter used in the Leader role. " alt="" coords="1565,625,1785,651"/>
<area shape="rect" id="node20" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="1851,511,2043,549"/>
<area shape="rect" id="node21" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="2091,511,2285,549"/>
<area shape="rect" id="node23" href="../../db/dec/group__core-mle-router.html#gac7d2542017033898d0bc0f17a65d4656" title="This method checks if the destination is reachable. " alt="" coords="1302,284,1464,323"/>
<area shape="rect" id="node24" href="../../db/dec/group__core-mle-router.html#gadf4904db11b31b2931f2f5ed1b988f83" title="This method fills an RouteTlv. " alt="" coords="1302,449,1464,488"/>
<area shape="rect" id="node26" href="../../dd/dd1/classThread_1_1NetworkData_1_1Local.html#a6688957845dc3ee7fc08bbc50145d98e" title="This method sends a Server Data Notification message to the Leader. " alt="" coords="1267,512,1499,551"/>
<area shape="rect" id="node25" href="../../d6/d17/classThread_1_1NetworkDiagnostic_1_1NetworkDiagnostic.html#aabefee38f58e0a8bcd39650ccc386e12" title="This method fills ChildTableTlv. " alt="" coords="1547,456,1803,495"/>
<area shape="rect" id="node27" href="../../db/da2/group__config-br.html#gaf9f7e49c190e8e11297d534e223d6274" title="Immediately register the local network data with the Leader. " alt="" coords="1610,519,1741,544"/>
<area shape="rect" id="node29" href="../../df/d94/group__core-mle-core.html#ga01c7e5a022360a6f35e30d07221dbfea" title="This method starts the MLE protocol operation. " alt="" coords="784,299,941,324"/>
<area shape="rect" id="node31" href="../../df/d94/group__core-mle-core.html#gafb51db61e6e184d664a9e7cc3833dcf4" title="This method sets the MLE Timeout value. " alt="" coords="1022,568,1219,593"/>
<area shape="rect" id="node33" href="../../df/d94/group__core-mle-core.html#ga453d94c377c5825a4a5e8b66a728e591" title="This method sets the Device Mode as reported in the Mode TLV. " alt="" coords="751,400,974,425"/>
<area shape="rect" id="node30" href="../../d0/d0a/group__commands.html#ga62fbc1cdb7b036df73975ca5683f8573" title="This function starts Thread protocol operation. " alt="" coords="1624,357,1726,383"/>
<area shape="rect" id="node32" href="../../df/d4f/group__config-general.html#ga6b28b99c77378da98922a3d994b7641c" title="Set the Thread Child Timeout used when operating in the Child role. " alt="" coords="1610,575,1740,600"/>
<area shape="rect" id="node34" href="../../df/d4f/group__config-general.html#ga8263fa852e25758aad3636bce0069a0d" title="Set the MLE Link Mode configuration. " alt="" coords="1620,407,1730,432"/>
<area shape="rect" id="node36" href="../../da/d6e/classThread_1_1AnnounceBeginServer.html#a0ec55dcc678b320251be99112cfc037b" title="This method begins the MLE Announce transmission process. " alt="" coords="761,184,965,223"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/core/crypto/<a class="el" href="../../d0/da7/aes__ccm_8hpp_source.html">aes_ccm.hpp</a></li>
<li>src/core/crypto/<a class="el" href="../../dc/dce/aes__ccm_8cpp.html">aes_ccm.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><b>Crypto</b></li><li class="navelem"><a class="el" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html">AesCcm</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
